﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Reactive.Concurrency;
using System.Reactive.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using System.Threading;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace RxSample.Part5
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();

            var input = (from evtPattern in Observable.FromEventPattern<TextChangedEventArgs>(tb, "TextChanged")
                         select ((TextBox)evtPattern.Sender).Text)
            .Throttle(TimeSpan.FromSeconds(1))
            .DistinctUntilChanged();

            //1
            //input.Subscribe(
            //    txt => Debug.WriteLine(txt));

            //2 - SynchronizationContext.Current
            input.ObserveOn(SynchronizationContext.Current)
                .Subscribe(
                inputText =>
                {
                    Debug.WriteLine("Search text : {0}", inputText);

                    tbMessage.Text = "Searching for " + inputText;

                    wv.Navigate(new Uri("http://en.wikipedia.org/wiki/" + inputText));
                });

            var navigated = Observable.FromEventPattern<WebViewNavigationCompletedEventArgs>(wv, "NavigationCompleted");

            var navigatting = Observable.FromEventPattern<WebViewNavigationStartingEventArgs>(wv, "NavigationStarting");

            navigatting.Subscribe(evtPattern =>
            {
                wv.Visibility = Visibility.Collapsed;
                tbMessage.Visibility = Visibility.Visible;
            });

            navigated.Subscribe(evtPattern =>
            {
                wv.Visibility = Visibility.Visible;
                tbMessage.Visibility = Visibility.Collapsed;
            });

            //var search = from inputText in input
            //    select wv.Navigate(new Uri("http://en.wikipedia.org/wiki/" + inputText));


            //var navigete = Observable.FromEventPattern<WebViewNavigationCompletedEventArgs>(wv, "NavigationCompleted");

        }



    }
}
